=== level_zero/core/source/xe_hp_core/CMakeLists.txt ===
#
# Copyright (C) 2021-2023 Intel Corporation
#
# SPDX-License-Identifier: MIT
#

if(SUPPORT_XE_HP_CORE)
  target_sources(${L0_STATIC_LIB_NAME} PRIVATE
                 ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt
                 ${CMAKE_CURRENT_SOURCE_DIR}/cmdlist_xe_hp_core.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/cmdlist_xe_hp_core.h
                 ${CMAKE_CURRENT_SOURCE_DIR}/image_xe_hp_core.inl
                 ${CMAKE_CURRENT_SOURCE_DIR}/sampler_xe_hp_core.inl
                 ${CMAKE_CURRENT_SOURCE_DIR}/enable_family_full_l0_xe_hp_core.cpp
                 ${CMAKE_CURRENT_SOURCE_DIR}/l0_gfx_core_helper_xe_hp_core.cpp
  )

  add_subdirectories()

endif()
