=== debian/changelog ===
intel-compute-runtime (23.35.27191.9-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 06 Oct 2023 13:06:45 +0300

intel-compute-runtime (23.35~git20230926-1) unstable; urgency=medium

  * New upstream release. (Closes: #1051189, #1052513)
  * Split packaging so ocloc and level zero files are in their own
    packages.
  * rules: Add get-orig-source target.

 -- Timo Aaltonen <tjaalton@debian.org>  Wed, 27 Sep 2023 11:28:03 +0300

intel-compute-runtime (23.13.26032.7-1) experimental; urgency=medium

  * New upstream release.
  * control: Bump igc build-depends.
  * control: Bump libze-dev build-dep.
  * rules: Skip unit tests.

 -- Timo Aaltonen <tjaalton@debian.org>  Sat, 15 Apr 2023 00:09:48 +0300
